# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventGrid::V2018_01_01
  module Models
    #
    # Properties of an event published to an Event Grid topic.
    #
    class EventGridEvent

      include MsRestAzure

      # @return [String] An unique identifier for the event.
      attr_accessor :id

      # @return [String] The resource path of the event source.
      attr_accessor :topic

      # @return [String] A resource path relative to the topic path.
      attr_accessor :subject

      # @return Event data specific to the event type.
      attr_accessor :data

      # @return [String] The type of the event that occurred.
      attr_accessor :event_type

      # @return [DateTime] The time (in UTC) the event was generated.
      attr_accessor :event_time

      # @return [String] The schema version of the event metadata.
      attr_accessor :metadata_version

      # @return [String] The schema version of the data object.
      attr_accessor :data_version


      #
      # Mapper for EventGridEvent class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EventGridEvent',
          type: {
            name: 'Composite',
            class_name: 'EventGridEvent',
            model_properties: {
              id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              topic: {
                client_side_validation: true,
                required: false,
                serialized_name: 'topic',
                type: {
                  name: 'String'
                }
              },
              subject: {
                client_side_validation: true,
                required: true,
                serialized_name: 'subject',
                type: {
                  name: 'String'
                }
              },
              data: {
                client_side_validation: true,
                required: true,
                serialized_name: 'data',
                type: {
                  name: 'Object'
                }
              },
              event_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'eventType',
                type: {
                  name: 'String'
                }
              },
              event_time: {
                client_side_validation: true,
                required: true,
                serialized_name: 'eventTime',
                type: {
                  name: 'DateTime'
                }
              },
              metadata_version: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'metadataVersion',
                type: {
                  name: 'String'
                }
              },
              data_version: {
                client_side_validation: true,
                required: true,
                serialized_name: 'dataVersion',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
