# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventGrid::V2018_01_01
  module Models
    #
    # Schema of the Data property of an EventGridEvent for an
    # Microsoft.EventHub.CaptureFileCreated event.
    #
    class EventHubCaptureFileCreatedEventData

      include MsRestAzure

      # @return [String] The path to the capture file.
      attr_accessor :fileurl

      # @return [String] The file type of the capture file.
      attr_accessor :file_type

      # @return [String] The shard ID.
      attr_accessor :partition_id

      # @return [Integer] The file size.
      attr_accessor :size_in_bytes

      # @return [Integer] The number of events in the file.
      attr_accessor :event_count

      # @return [Integer] The smallest sequence number from the queue.
      attr_accessor :first_sequence_number

      # @return [Integer] The last sequence number from the queue.
      attr_accessor :last_sequence_number

      # @return [DateTime] The first time from the queue.
      attr_accessor :first_enqueue_time

      # @return [DateTime] The last time from the queue.
      attr_accessor :last_enqueue_time


      #
      # Mapper for EventHubCaptureFileCreatedEventData class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EventHubCaptureFileCreatedEventData',
          type: {
            name: 'Composite',
            class_name: 'EventHubCaptureFileCreatedEventData',
            model_properties: {
              fileurl: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fileurl',
                type: {
                  name: 'String'
                }
              },
              file_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fileType',
                type: {
                  name: 'String'
                }
              },
              partition_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'partitionId',
                type: {
                  name: 'String'
                }
              },
              size_in_bytes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sizeInBytes',
                type: {
                  name: 'Number'
                }
              },
              event_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'eventCount',
                type: {
                  name: 'Number'
                }
              },
              first_sequence_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'firstSequenceNumber',
                type: {
                  name: 'Number'
                }
              },
              last_sequence_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastSequenceNumber',
                type: {
                  name: 'Number'
                }
              },
              first_enqueue_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'firstEnqueueTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_enqueue_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastEnqueueTime',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
